=== debian/changelog ===
nvidia-cuda-toolkit (7.5.18-0ubuntu1) xenial; urgency=medium

  [ Zhou Mo ]
  * New upstream release 7.5 (Sept 2015).  (Closes: #807579)
  * SOVERSION bump: 7.0 => 7.5, rename all library packages.
  * Update symbols control files. 
  * [ppc64el] Adjust location of nvvm/lib.
  * Update Lintian overrides.

  [ Andreas Beckmann ]
  * Refresh man-sections.patch.
  * debian/copyright: Synchronize with updated EULA.txt.
  * Use multiarch substitution in nvcc.profile.
  * gcc-support.patch: New, allow usage of GCC 5.
  * Use gcc-5/g++-5 as preferred compiler.
  * Update documentation regarding the CUDA Code Samples.
  * [ppc64el] Use the no-libcuda1 virtual package on Ubuntu.
  * Upload to experimental.

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 30 Mar 2016 12:54:00 +0200

nvidia-cuda-toolkit (7.0.28-4) unstable; urgency=medium

  * [ppc64el] Enable the nvidia-opencl-dev package.
  * Ship nvprune manpage.
  * rules: Enforce that arch:all documentation packages are built on amd64 only.
  * get-orig-source: Exclude driver and GPU Deployment Kit.
  * Drop Conflicts/Breaks/Replaces targeting pre-jessie versions.
  * Add Conflicts with the CUDA repo packages from NVIDIA for Ubuntu.
  * man-typos.patch: Fix more misspellings.
  * Bump Standards-Version to 3.9.7 (no changes needed).
  * Update Lintian overrides.  (Closes: #815822)

 -- Andreas Beckmann <anbe@debian.org>  Sun, 28 Feb 2016 14:02:08 +0100

nvidia-cuda-toolkit (7.0.28-3) unstable; urgency=medium

  [ Andreas Beckmann ]
  * Drop Build-Depends on libcuda1 and always use the libcuda.so stub (with
    some postprocessing) for dependency resolution.
  * Revert the no-libcuda1 virtual package hack.

  [ Graham Inggs ]
  * [ppc64el] Add Build-Depends on libexpat1.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 17 Feb 2016 08:33:34 +0100

nvidia-cuda-toolkit (7.0.28-2) unstable; urgency=medium

  * Merge changes from 6.5.19-3.
  * get-orig-source: Generate an additional .orig-ppc64el tarball by repacking
    cuda-repo-ubuntuAABB-X-Y-local_*_ppc64el.deb.
  * Add preliminary support for building ppc64el packages.
  * Work around libcuda1 not being available on ppc64el:
    - Use the stub library shipped with the library for dependency resolution.
    - libcudart7.0:ppc64el: Provide virtual package no-libcuda1 and use that
      as alternative dependency.
  * [ppc64el] Strip RPATH from cuda-gdb.
  * Apply the patches over the nvidia-cuda symlink.
  * Update Lintian overrides.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 03 Feb 2016 09:43:31 +0100

nvidia-cuda-toolkit (7.0.28-1) experimental; urgency=medium

  [ Zhou Mo ]
  * New upstream release 7.0 (March 2015).  (Closes: #783770)
  * Drop i386 support for all remaining packages, removed upstream.
  * SOVERSION bump: 6.5 => 7.0, rename all library packages and
    bump alternate virtual B-D to libcuda-7.0-1.
  * libnvvm SOVERSION bump: 2 => 3, rename libnvvm2 to libnvvm3.
  * Update symbols control files.
  * Do not ship open64 binaries, no longer provided upstream.
    (Closes: #774297)
  * Ship new headers and nvprune binary.
  * libcusolver7.0: New package for the cuSOLVER library.
  * libnvrtc7.0: New package for the NVRTC library.

  [ Andreas Beckmann ]
  * Refresh man-sections.patch and man-typos.patch.
  * debian/copyright: Synchronize with updated EULA.txt.
  * nvidia-cuda-dev: Ship the library stubs, downgrade Depends: libcuda1 to
    Recommends.
  * Remove compatibility symlink for thrust includes.
  * Update documentation regarding the CUDA Code Samples.
  * nvidia-visual-profiler, nvidia-nsight: Disable more tracking scripts.
  * Update Lintian overrides.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 28 Nov 2015 07:35:39 +0100

nvidia-cuda-toolkit (6.5.19-3) unstable; urgency=medium

  * Do not run dh_strip_nondeterminism, it may perform modifications not
    permitted by the NVIDIA license.
  * get-orig-source: Generate tarball reproducibly.
  * Add Zhou Mo to Uploaders.
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 20 Jan 2016 03:11:45 +0100

nvidia-cuda-toolkit (6.5.19-2) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 13 Nov 2015 19:46:02 +0100

nvidia-cuda-toolkit (6.5.19-1) experimental; urgency=medium

  * New upstream release 6.5 (September 2014).
    - Adding support for GTX9xx GPUs. (Needs a 343.xx or newer driver.)
  * Refresh man-sections.patch.
  * Update symbols control files.
  * Update Lintian overrides.
  * nvidia-cuda-toolkit: Suggest nvidia-driver and mention in the long
    description that an NVIDIA GPU and the NVIDIA driver kernel module are
    required to run CUDA applications.  (Closes: #795262)
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 05 Oct 2015 23:26:43 +0200
