=== debian/watch ===
version=3
https://developer.nvidia.com/cuda-downloads .*/cuda_([0-9.]*)_linux.run
https://developer.nvidia.com/cuda-downloads .*/cuda_(.*)_linux_32.run
https://developer.nvidia.com/cuda-downloads .*/cuda_(.*)_linux_64.run
https://developer.nvidia.com/cuda-downloads .*/cuda_(.*)_linux_aarch64_native.run

# source code for nvopencc and cuda-gdb is available here:
# ftp://download.nvidia.com/CUDAOpen64/
